#include <stdio.h>
#include <string.h>
#include <stdint.h>

uint32_t coeff[16] = {
	0x00000000, 0x1DB71064, 0x3B6E20C8, 0x26D930AC, 0x76DC4190, 0x6B6B51F4, 0x4DB26158, 0x5005713C, 
	0xEDB88320, 0xF00F9344, 0xD6D6A3E8, 0xCB61B38C, 0x9B64C2B0, 0x86D3D2D4, 0xA00AE278, 0xBDBDF21C		
};

uint32_t crc32(const uint8_t* string, int len)
{
	uint32_t res = 0xffffffff;
	int i, j;
	
	for (i = 0; i < len; i++)
	{
		j = (string[i] ^ res) & 0xf;
		res = (res >> 4) ^ coeff[j];
		j = ((string[i] >> 4) ^ res) & 0xf;
		res = (res >> 4) ^ coeff[j];
	}
	
	return res;
}

int main(int argc, char** argv)
{
	int i;
	for (i = 1; i < argc; i++)
		printf("%08x - %s\n", crc32(argv[i], strlen(argv[i])), argv[i]);
	return 0;
}
